package hatenahaiku4j;

import hatenahaiku4j.util.HatenaUtil;

import java.util.Date;
import java.util.List;

/**
 * ͂ĂȃnCNXe[^X\NX
 * 
 * @since v0.0.1
 * @author fumokmm
 */
public class Status {
	/** Xe[^XID */
	private String id;
	/** 쐬 */
	private Date createdAt;
	/** CɓiĂꂽlj */
	private int favorited;
	/** ԐMXe[^XID */
	private String inReplyToStatusId;
	/** ԐM[UID */
	private String inReplyToUserId;
	/** L[[h */
	private String keyword;
	/** N */
	private String link;
	/** ̃Xe[^Xւ̕ԐM */
	private List<Status> replies;
	/** \[XiNCAgj */
	private String source;
	/** ee */
	private String text;
	/** [U */
	private User user;
	
	/** ̃Xe[^Xւ̕ԐMƂĎ擾eǂ */
	private boolean shadow;
	/** Xe[^XAPI */
	public final StatusAPI api;

	/**
	 * RXgN^łBipbP[WvCx[gj
	 * 
	 * @since v0.0.1
	 */
	private Status() {
		this.api = new StatusAPI();
	}
	
	/**
	 * w肵[Uł̃[U㏑܂B
	 * 
	 * @param other ㏑郆[U
	 * @since v0.2.0
	 */
	void overwrite(Status other) {
		this.id = other.id;
		this.createdAt = other.createdAt;
		this.favorited = other.favorited;
		this.inReplyToStatusId = other.inReplyToStatusId;
		this.inReplyToUserId = other.inReplyToUserId;
		this.keyword = other.keyword;
		this.link = other.link;
		this.replies = other.replies;
		this.source = other.source;
		this.text = other.text;
		this.user = other.user;
		this.shadow = other.shadow;
	}
	
	/**
	 * CX^X擾܂BipbP[WvCx[gj
	 * 
	 * @param apiAuth ͂ĂȃnCNAPIiF؂j
	 * @since v0.2.0
	 */
	static Status create(HatenaHaikuAPI apiAuth) {
		Status status = new Status();
		status.api.init(status, apiAuth);
		return status;
	}

	/**
	 * CX^X擾܂BipbP[WvCx[gj
	 * 
	 * @param apiLight ͂ĂȃnCNAPIiF؂Ȃj
	 * @since v0.2.0
	 */
	static Status create(HatenaHaikuAPILight apiLight) {
		Status status = new Status();
		status.api.init(status, apiLight);
		return status;
	}
	
	/**
	 * Xe[^XID擾܂B
	 * 
	 * @return Xe[^XID 
	 * @since v0.0.1
	 */
	public String getStatusId() {
		return id;
	}

	/**
	 * 쐬擾܂B
	 * 
	 * @return 쐬
	 * @since v0.0.1
	 */
	public Date getCreatedAt() {
		return createdAt;
	}

	/**
	 * 쐬͂Ăȓt`Ŏ擾܂B
	 * 
	 * @return 쐬i͂Ăȓt`j
	 * @since v0.2.0
	 */
	public String getCreatedAtString() {
		return HatenaUtil.formatDate(createdAt);
	}

	/**
	 * CɓiĂꂽlj擾܂B<br/>
	 * tX^[̐łȂƂɒӂĂB
	 * 
	 * @return CɓiĂꂽlj
	 * @since v0.0.1
	 */
	public int getFavorited() {
		return favorited;
	}

	/**
	 * ԐMXe[^XID擾܂B
	 * 
	 * @return ԐMXe[^XID
	 * @since v0.0.1
	 */
	public String getInReplyToStatusId() {
		return inReplyToStatusId;
	}

	/**
	 * ԐM[UID擾܂B
	 * 
	 * @return ԐM[UID
	 * @since v0.0.1
	 */
	public String getInReplyToUserId() {
		return inReplyToUserId;
	}

	/**
	 * L[[h擾܂B
	 * 
	 * @return L[[h 
	 * @since v0.0.1
	 */
	public String getKeyword() {
		return keyword;
	}

	/**
	 * idy[Wǂ擾܂B
	 * 
	 * @return idy[Wǂ
	 * @since v0.0.1
	 */
	public boolean isIdPage() {
		return HatenaUtil.isIdNotation(keyword);
	}

	/**
	 * N擾܂B
	 * 
	 * @return N 
	 * @since v0.0.1
	 */
	public String getLink() {
		return link;
	}

	/**
	 * oCpN擾܂B
	 * 
	 * @return oCpN 
	 * @since v1.0.0
	 */
	public String getMobileLink() {
		return link.replace(Const.BASE_URL, Const.BASE_URL + Const.MOBILE + "/");
	}

	/**
	 * ̃Xe[^Xւ̕ԐMԋp܂B
	 * 
	 * @return ̃Xe[^Xւ̕ԐM
	 * @since v0.1.0
	 */
	public List<Status> getReplies() {
		// XVȂ
		if (api.apiLight.isAutoRefreshReplies()) {
			if (shadow) {
				try {
					this.api.refreshReplies();
				} catch (HatenaHaikuException e) {
					System.out.println("ԐM擾sB");
				}
			}
		}
		return replies;
	}
	
	/**
	 * \[XiNCAgj擾܂B
	 * 
	 * @return \[XiNCAgj
	 * @since v0.0.1
	 */
	public String getSource() {
		return source;
	}

	/**
	 * ee擾܂B
	 * 
	 * @return ee
	 * @since v0.0.1
	 */
	public String getText() {
		return text;
	}

	/**
	 * [U擾܂B
	 * 
	 * @return [U
	 * @since v0.0.1
	 */
	public User getUser() {
		return user;
	}
	
	/**
	 * [UID擾܂B
	 * 
	 * {@link #getUser()}Ŏ擾ł郆[U{@link User#getUserId()}̃GCAXłB
	 * @return [UID
	 * @since v0.0.1
	 */
	public String getUserId() {
		return user.getUserId();
	}

	/**
	 * idL@̃[UID擾܂B<br/>
	 * {@link #getUser()}Ŏ擾ł郆[U{@link User#getUserIdNotation()}̃GCAXłB
	 * 
	 * @return [UidL@
	 * @since v0.2.0
	 */
	public String getUserIdNotation() {
		return user.getUserIdNotation();
	}

	/**
	 * ̃Xe[^Xւ̕ԐMƂĎ擾eǂ擾܂B
	 * 
	 * @return ̃Xe[^Xւ̕ԐMƂĎ擾eǂ
	 * @since v0.1.0
	 */
	public boolean isShadow() {
		return shadow;
	}
	
	/**
	 * Xe[^XIDݒ肵܂B
	 * 
	 * @param statusId Xe[^XID
	 * @since v0.0.1
	 */
	void setStatusId(String statusId) {
		this.id = statusId;
	}

	/**
	 * 쐬ݒ肵܂B
	 * 
	 * @param createdAt@쐬
	 * @since v0.0.1
	 */
	void setCreatedAt(Date createdAt) {
		this.createdAt = createdAt;
	}

	/**
	 * Cɓݒ肵܂B
	 * 
	 * @param favorited Cɓ
	 * @since v0.0.1
	 */
	void setFavorited(int favorited) {
		this.favorited = favorited;
	}

	/**
	 * ԐMXe[^XIDݒ肵܂B
	 * 
	 * @param inReplyToStatusId ԐMXe[^XID
	 * @since v0.0.1
	 */
	void setInReplyToStatusId(String inReplyToStatusId) {
		this.inReplyToStatusId = inReplyToStatusId;
	}

	/**
	 * ԐM[UIDݒ肵܂B
	 * 
	 * @param inReplyToUserId ԐM[UID
	 * @since v0.0.1
	 */
	void setInReplyToUserId(String inReplyToUserId) {
		this.inReplyToUserId = inReplyToUserId;
	}

	/**
	 * L[[hݒ肵܂B
	 * 
	 * @param keyword L[[h
	 * @since v0.0.1
	 */
	void setKeyword(String keyword) {
		this.keyword = keyword;
	}

	/**
	 * Nݒ肵܂B
	 * 
	 * @param link N
	 * @since v0.0.1
	 */
	void setLink(String link) {
		this.link = link;
	}

	/**
	 * ̃Xe[^Xւ̕ԐMݒ肵܂B
	 * 
	 * @param replies ̃Xe[^Xւ̕ԐM
	 * @since v0.0.1
	 */
	void setReplies(List<Status> replies) {
		this.replies = replies;
	}
	
	/**
	 * \[XiNCAgjݒ肵܂B
	 * 
	 * @param source \[XiNCAgj
	 * @since v0.0.1
	 */
	void setSource(String source) {
		this.source = source;
	}

	/**
	 * eeݒ肵܂B
	 * 
	 * @param text ee
	 * @since v0.0.1
	 */
	void setText(String text) {
		this.text = text;
	}

	/**
	 * [Uݒ肵܂B
	 * 
	 * @param user [U
	 * @since v0.0.1
	 */
	void setUser(User user) {
		this.user = user;
	}
	
	/**
	 * ̃Xe[^Xւ̕ԐMƂĎ擾eǂݒ肵܂B
	 * 
	 * @param shadow ̃Xe[^Xւ̕ԐMƂĎ擾eǂ
	 * @since v0.1.0
	 */
	void setShadow(boolean shadow) {
		this.shadow = shadow;
	}

	/**
	 * text́uxxxx={v "xxxx="菜B<br/>
	 * OFkeyword, textݒ肳Ă邱ƁBikeywordidy[W̏ꍇid:xxx`Ŋi[ς݂ł邱Ɓj
	 * 
	 * @since v0.1.0
	 */
	void removeKeywordEqualOnText() {
		if (!"".equals(keyword) && !isIdPage()) {
			// 󔒂łidy[WłȂꍇAtextɂ́uL[[h=vɂĂ̂ŁA菜
			text = text.substring(keyword.length() + 1);
		}
	}
}

/* ------ sample xml ---------------------------
<?xml version='1.0' standalone='yes'?>
<statuses type="array">
  <status>
    <id>12345678901234</id>
    <created_at>2008-08-19T00:00:00Z</created_at>
    <favorited>0</favorited>
    <in_reply_to_status_id>98765432109876</in_reply_to_status_id>
    <in_reply_to_user_id>jkondo</in_reply_to_user_id>

    <keyword>͂ĂȃftHg</keyword>
    <link>http://h.hatena.ne.jp/jkondo/12345678901234</link>
    <replies>                                         |
    	in_reply_to_status_id, in_reply_to_user_id    | Areplies
		keyword, link, replies <status>           | gbvxstatusɂ̂ݕtB
	</replies>                                        |
		E
		EȉԐM敪ArepliešJԂ
		E
    <source>web</source>
    <text>͂ĂȃftHg=ɂ́A킢ftHgłˁB</text>
    <user>
      <name>jkondo</name>
      <followers_count>1</followers_count>
      <id>jkondo</id>
      <profile_image_url>http://www.hatena.ne.jp/users/jk/jkondo/profile.gif</profile_image_url>
      <screen_name>jkondo</screen_name>
      <url>http://h.hatena.ne.jp/jkondo/</url>
    </user>
  </status>
  <!-- status vf܂B -->
</statuses>
--------------------------------------------- */
