package hatenahaiku4j;

import java.io.File;

/**
 * Xe[^XɊւAPI
 * 
 * @since v0.2.0
 * @author fumokmm
 */
public class StatusAPI extends EntityAPI {
	/** Xe[^X */
	private Status status;

	/**
	 * RXgN^BipbP[WvCx[gj
	 * 
	 * @since v0.2.0
	 */
	StatusAPI() {
		super();
	}

	/**
	 * ܂B
	 * 
	 * @param status Xe[^X
	 * @param apiAuth ͂ĂȃnCNAPIiF؂j
	 * @since v0.2.0
	 */
	void init(Status status, HatenaHaikuAPI apiAuth) {
		this.status = status;
		this.apiAuth = apiAuth;
		this.apiLight = apiAuth;
	}

	/**
	 * ܂B
	 * 
	 * @param status Xe[^X
	 * @param apiLight ͂ĂȃnCNAPIiF؂Ȃj
	 * @since v0.2.0
	 */
	void init(Status status, HatenaHaikuAPILight apiLight) {
		this.status = status;
		this.apiLight = apiLight;
	}
	
	/**
	 * ̃Xe[^XԐMԂɎ擾Ȃ܂B
	 * 
	 * @see HatenaHaikuAPILight#getStatus(String)
	 * @return ԐMԂ擾Ȃꂽ̃Xe[^X
	 * @since v0.2.0
	 */
	Status refreshReplies() throws HatenaHaikuException {
		Status newStatus = apiLight.getStatus(status.getStatusId());
		status.setReplies(newStatus.getReplies());
		status.setShadow(false);
		return this.status;
	}
	
	// ------------------ȉAF؂svAPI

	/**
	 * ̃Xe[^X̃[U擾܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/friendships/show/<font color="red">[UID</font>.xml</i>
	 * 
	 * @see HatenaHaikuAPILight#getUser(String)
	 * @return w肵[U
	 * @throws HatenaHaikuException
	 * @since v0.2.0
	 */
	public User getUser() throws HatenaHaikuException {
		return apiLight.getUser(status.getUserId());
	}
	
	/**
	 * ̃Xe[^X̃L[[h擾܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/keywords/show/<font color="red">L[[h</font>.xml</i>
	 * 
	 * @see HatenaHaikuAPILight#getKeyword(String)
	 * @return w肵L[[h
	 * @throws HatenaHaikuException
	 * @since v0.2.0
	 */
	public Keyword getKeyword() throws HatenaHaikuException {
		return apiLight.getKeyword(status.getKeyword());
	}
	
	// ------------------ȉAF؂KvAPI
	
	/**
	 * ̃GgɐVԐMGg𓊍e܂B
	 * 
	 * @see HatenaHaikuAPI#reply(String, String)
	 * @param text ee
	 * @return eʂ̃Xe[^X
	 * @throws HatenaHaikuException
	 * @since v0.2.0
	 */
	public Status reply(String text) throws HatenaHaikuException {
		if (isAuth()) {
			return apiAuth.reply(status.getStatusId(), text);
		} else {
			throw new HatenaHaikuException("F؂Kv܂BHatenaHaikuAPIpB");
		}
	}

	/**
	 * ̃GgɐVԐMGg𓊍e܂B<br/>
	 * 摜tŃGg܂B
	 * 
	 * @see HatenaHaikuAPI#reply(String, String, File)
	 * @param text ee
	 * @param file 摜t@C
	 * @return eʂ̃Xe[^X
	 * @throws HatenaHaikuException
	 * @since v1.0.0
	 */
	public Status reply(String text, File file) throws HatenaHaikuException {
		if (isAuth()) {
			return apiAuth.reply(status.getStatusId(), text, file);
		} else {
			throw new HatenaHaikuException("F؂Kv܂BHatenaHaikuAPIpB");
		}
	}
	
	/**
	 * ̃GgɐVԐMGg𓊍e܂B<br/>
	 * URLɂ摜tŃGg܂B
	 * 
	 * @see HatenaHaikuAPI#reply(String, String, String)
	 * @param text ee
	 * @param imageUrl 摜URL
	 * @return eʂ̃Xe[^X
	 * @throws HatenaHaikuException
	 * @since v1.0.0
	 */
	public Status reply(String text, String imageUrl) throws HatenaHaikuException {
		if (isAuth()) {
			return apiAuth.reply(status.getStatusId(), text, imageUrl);
		} else {
			throw new HatenaHaikuException("F؂Kv܂BHatenaHaikuAPIpB");
		}
	}
	
	/**
	 * ̃GgɐVԐMGg𓊍e܂B<br/>
	 * 摜̃oCif[^Ƃ̊gqw肵A摜tŃGg܂B
	 * 
	 * @see HatenaHaikuAPI#reply(String, String, byte[], ImageExt)
	 * @param text ee
	 * @param imageData 摜̃oCif[^
	 * @param imageDataExt 摜̊gq
	 * @return eʂ̃Xe[^X
	 * @throws HatenaHaikuException
	 * @since v1.0.0
	 */
	public Status reply(String text, byte[] imageData, ImageExt imageDataExt) throws HatenaHaikuException {
		if (isAuth()) {
			return apiAuth.reply(status.getStatusId(), text, imageData, imageDataExt);
		} else {
			throw new HatenaHaikuException("F؂Kv܂BHatenaHaikuAPIpB");
		}
	}
	
	/**
	 * ̃Gg폜܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/destroy/<font color="red">Xe[^XID</font>.xml</i>
	 * 
	 * @see HatenaHaikuAPI#deleteEntry(String)
	 * @return ̍폜Xe[^X
	 * @throws HatenaHaikuException 
	 * @since v0.2.0
	 */
	public Status delete() throws HatenaHaikuException {
		if (isAuth()) {
			Status deleted = apiAuth.deleteEntry(status.getStatusId());
			status.overwrite(deleted);
			return status;
		} else {
			throw new HatenaHaikuException("F؂Kv܂BHatenaHaikuAPIpB");
		}
	}
	
	/**
	 * ̃GgɃX^[ǉ܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/favorites/create/<font color="red">Xe[^XID</font>.xml</i>
	 * 
	 * @see HatenaHaikuAPI#addStar(String)
	 * @return X^[ǉʂ̂̃Xe[^X
	 * @throws HatenaHaikuException 
	 * @since v0.2.0
	 */
	public Status addStar() throws HatenaHaikuException {
		if (isAuth()) {
			Status starAdded = apiAuth.addStar(status.getStatusId());
			status.overwrite(starAdded);
			return status;
		} else {
			throw new HatenaHaikuException("F؂Kv܂BHatenaHaikuAPIpB");
		}
	}

	/**
	 * w肵Gg̃X^[炵܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/favorites/destroy/<font color="red">Xe[^XID</font>.xml</i>
	 * 
	 * @see HatenaHaikuAPI#deleteStar(String)
	 * @return X^[炵ʂ̂̃Xe[^X
	 * @throws HatenaHaikuException 
	 * @since v0.2.0
	 */
	public Status deleteStar() throws HatenaHaikuException {
		if (isAuth()) {
			Status starDeleted = apiAuth.deleteStar(status.getStatusId());
			status.overwrite(starDeleted);
			return status;
		} else {
			throw new HatenaHaikuException("F؂Kv܂BHatenaHaikuAPIpB");
		}
	}

}
