package hatenahaiku4j;

/**
 * ͂ĂȃnCN[U\NX
 * 
 * @since v0.0.1
 * @author fumokmm
 */
public class User {
	/** [U */
	private String name;
	/** tH[ */
	private int followersCount;
	/** [UID */
	private String id;
	/** vtB[摜URL */
	private String profileImageUrl;
	/** \ */
	private String screenName;
	/** [ŨGgy[WURL */
	private String url;

	/** [UAPI */
	public final UserAPI api;

	/**
	 * RXgN^łBipbP[WvCx[gj
	 * 
	 * @since v0.0.1
	 */
	private User() {
		this.api = new UserAPI();
	}
	
	/**
	 * w肵[Uł̃[U㏑܂B
	 * 
	 * @param other ㏑郆[U
	 * @since v0.2.0
	 */
	void overwrite(User other) {
		this.name = other.name;
		this.followersCount = other.followersCount;
		this.id = other.id;
		this.profileImageUrl = other.profileImageUrl;
		this.screenName = other.screenName;
		this.url = other.url;
	}
	
	/**
	 * CX^X擾܂BipbP[WvCx[gj
	 * 
	 * @param apiAuth ͂ĂȃnCNAPIiF؂j
	 * @since v0.2.0
	 */
	static User create(HatenaHaikuAPI apiAuth) {
		User user = new User();
		user.api.init(user, apiAuth);
		return user;
	}

	/**
	 * CX^X擾܂BipbP[WvCx[gj
	 * 
	 * @param apiLight ͂ĂȃnCNAPIiF؂Ȃj
	 * @since v0.2.0
	 */
	static User create(HatenaHaikuAPILight apiLight) {
		User user = new User();
		user.api.init(user, apiLight);
		return user;
	}

	/**
	 * [U擾܂B
	 * 
	 * @return [U
	 * @since v0.0.1
	 */
	public String getName() {
		return name;
	}
	
	/**
	 * tH[擾܂B
	 * 
	 * @return tH[
	 * @since v0.0.1
	 */
	public int getFollowersCount() {
		return followersCount;
	}

	/**
	 * [UID擾܂B
	 * 
	 * @return [UID
	 * @since v0.0.1
	 */
	public String getUserId() {
		return id;
	}

	/**
	 * idL@̃[UID擾܂B (id:xxx)
	 * 
	 * @return [UidL@ (id:xxx)
	 * @since v0.2.0
	 */
	public String getUserIdNotation() {
		return Const.ID_COLON + id;
	}
	
	/**
	 * vtB[摜URL擾܂B
	 * 
	 * @return vtB[摜URL
	 * @since v0.0.1
	 */
	public String getProfileImageUrl() {
		return profileImageUrl;
	}
	
	/**
	 * vtB[摜()URL擾܂B
	 * 
	 * @return vtB[摜()URL
	 * @since v0.0.1
	 */
	public String getProfileImageSmallUrl() {
		return profileImageUrl.replaceFirst("profile\\.gif$", "profile_s.gif");
	}
	
	/**
	 * \擾܂B
	 * 
	 * @return \
	 * @since v0.0.1
	 */
	public String getScreenName() {
		return screenName;
	}

	/**
	 * [ŨGgy[WURL擾܂B
	 * 
	 * @return [ŨGgy[WURL
	 * @since v0.0.1
	 */
	public String getEntriesUrl() {
		return url;
	}
	
	/**
	 * oCp[ŨGgy[WURL擾܂B
	 * 
	 * @return oCp[ŨGgy[WURL
	 * @since v1.0.0
	 */
	public String getMobileEntriesUrl() {
		return url.replace(Const.BASE_URL, Const.BASE_URL + Const.MOBILE + "/");
	}

	/**
	 * [ŨtHEBOy[WURL擾܂B
	 * 
	 * @return [ŨtHEBOy[WURL
	 * @since v0.0.1
	 */
	public String getFollowingUrl() {
		return getEntriesUrl() + Const.FOLLOWING;
	}
	
	/**
	 * [UIDy[WURL擾܂B
	 * 
	 * @return [ŨvtB[y[WURL
	 * @since v0.0.1
	 */
	public String getIdUrl() {
		return Const.BASE_URL + Const.ID + "/" + getUserId();
	}

	/**
	 * oCp[UIDy[WURL擾܂B
	 * 
	 * @return oCp[ŨvtB[y[WURL
	 * @since v1.0.0
	 */
	public String getMobileIdUrl() {
		return Const.BASE_URL + Const.MOBILE + "/" + Const.ID + "/" + getUserId();
	}

	/**
	 * [Uݒ肵܂B
	 * 
	 * @param name [U
	 * @since v0.0.1
	 */
	void setName(String name) {
		this.name = name;
	}
	
	/**
	 * tH[ݒ肵܂B
	 * 
	 * @param followersCount tH[
	 * @since v0.0.1
	 */
	void setFollowersCount(int followersCount) {
		this.followersCount = followersCount;
	}

	/**
	 * [UIDݒ肵܂B
	 * 
	 * @param userId [UID
	 * @since v0.0.1
	 */
	void setUserId(String userId) {
		this.id = userId;
	}

	/**
	 * vtB[摜URLݒ肵܂B
	 * 
	 * @param profileImageUrl vtB[摜URL
	 * @since v0.0.1
	 */
	void setProfileImageUrl(String profileImageUrl) {
		this.profileImageUrl = profileImageUrl;
	}
	
	/**
	 * \ݒ肵܂B
	 * 
	 * @param screenName \
	 * @since v0.0.1
	 */
	void setScreenName(String screenName) {
		this.screenName = screenName;
	}
	
	/**
	 * [ŨGgy[WURLݒ肵܂B
	 * 
	 * @param url [ŨGgy[WURL
	 * @since v0.0.1
	 */
	void setUrl(String url) {
		this.url = url;
	}

}

/* ------ sample xml ---------------------------
<user>
	<name>jkondo</name>
	<followers_count>1</followers_count>
	<id>jkondo</id>
	<profile_image_url>http://www.hatena.ne.jp/users/jk/jkondo/profile.gif</profile_image_url>
	<screen_name>jkondo</screen_name>
	<url>http://h.hatena.ne.jp/jkondo/</url>
</user>
--------------------------------------------- */
